(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('angular'), require('tslib'), require('angular-mocks'), require('angular-ts-decorators')) :
	typeof define === 'function' && define.amd ? define(['exports', 'angular', 'tslib', 'angular-mocks', 'angular-ts-decorators'], factory) :
	(factory((global['angularjs-testbed'] = global['angularjs-testbed'] || {}),global.angular,global.tslib,global['angular-mocks'],global['angular-ts-decorators']));
}(this, (function (exports,angular,tslib_1,angularMocks,angularTsDecorators) { 'use strict';

var By = /** @class */ (function () {
    function By() {
    }
    By.css = function (selector) {
        return selector;
    };
    return By;
}());

/**
 * Extend JQLite with query method (will work only if JQuery included)
 */
angular.element.prototype.query = angular.element.prototype.find;
/**
 * Extend JQLite with nativeElement property
 */
Object.defineProperty(angular.element.prototype, 'nativeElement', {
    get: function () { return this[0]; },
    configurable: false
});
var ComponentFixture = /** @class */ (function () {
    function ComponentFixture(element$$1) {
        this.element = element$$1;
        /** @internal */
        this._isDestroyed = false;
        this.componentInstance = element$$1.isolateScope()['$ctrl'];
        this.debugElement = element$$1;
        this.nativeElement = this.debugElement.nativeElement;
    }
    /**
     * Trigger a change detection cycle for the component.
     */
    ComponentFixture.prototype.detectChanges = function () {
        this.element.scope().$digest();
    };
    /**
     * Trigger component destruction.
     */
    ComponentFixture.prototype.destroy = function () {
        if (!this._isDestroyed) {
            this.element.detach();
            this._isDestroyed = true;
        }
    };
    return ComponentFixture;
}());

/** @internal */
var DynamicTestModuleId = 'DynamicTestModule';
/**
 * @whatItDoes Configures and initializes environment for unit testing and provides methods for
 * creating components and services in unit tests.
 * @description
 *
 * TestBed is the primary api for writing unit tests for Angular applications and libraries.
 *
 * @stable
 */
var TestBed = /** @class */ (function () {
    function TestBed() {
        /** @internal */
        this._providers = [];
        /** @internal */
        this._declarations = [];
        /** @internal */
        this._imports = [];
        /** @internal */
        this._activeFixtures = [];
        /** @internal */
        this._moduleRef = null;
        /** @internal */
        this._instantiated = false;
    }
    /**
     * Allows overriding default providers, directives, pipes, modules of the test injector,
     * which are defined in test_injector.js
     */
    TestBed.configureTestingModule = function (moduleDef) {
        getTestBed().configureTestingModule(moduleDef);
        return TestBed;
    };
    TestBed.resetTestingModule = function () {
        getTestBed().resetTestingModule();
        return TestBed;
    };
    TestBed.createComponent = function (component) {
        return getTestBed().createComponent(component);
    };
    /** @internal */
    TestBed.prototype.configureTestingModule = function (moduleDef) {
        if (moduleDef.providers) {
            (_a = this._providers).push.apply(_a, moduleDef.providers);
        }
        if (moduleDef.declarations) {
            (_b = this._declarations).push.apply(_b, moduleDef.declarations);
        }
        if (moduleDef.imports) {
            (_c = this._imports).push.apply(_c, moduleDef.imports);
        }
        var _a, _b, _c;
    };
    /** @internal */
    TestBed.prototype.resetTestingModule = function () {
        this._moduleRef = null;
        this._providers = [];
        this._declarations = [];
        this._imports = [];
        this._instantiated = false;
        this._activeFixtures.forEach(function (fixture) {
            try {
                fixture.destroy();
            }
            catch (e) {
                console.error('Error during cleanup of component', fixture.componentInstance);
            }
        });
        this._activeFixtures = [];
    };
    /** @internal */
    TestBed.prototype.createComponent = function (component) {
        var _this = this;
        this._initIfNeeded();
        var initComponent = function () {
            var componentRef = _this._compileComponent(component);
            return new ComponentFixture(componentRef);
        };
        var fixture = initComponent();
        this._activeFixtures.push(fixture);
        return fixture;
    };
    /** @internal */
    TestBed.prototype._initIfNeeded = function () {
        if (this._instantiated) {
            return;
        }
        this._createModule();
        this._instantiated = true;
    };
    /** @internal */
    TestBed.prototype._createModule = function () {
        var providers = this._providers;
        var declarations = this._declarations;
        var imports = this._imports;
        var DynamicTestModule = /** @class */ (function () {
            function DynamicTestModule() {
            }
            DynamicTestModule = tslib_1.__decorate([
                angularTsDecorators.NgModule({ id: DynamicTestModuleId, providers: providers, declarations: declarations, imports: imports })
            ], DynamicTestModule);
            return DynamicTestModule;
        }());
        angular.mock.module(DynamicTestModuleId);
        return DynamicTestModule;
    };
    /** @internal */
    TestBed.prototype._compileComponent = function (component) {
        var componentName = angularTsDecorators.getTypeName(component);
        var selector = camelToKebab(componentName);
        var $div = "<" + selector + "></" + selector + ">";
        var element$$1 = null;
        inject(function ($compile, $rootScope) {
            var $scope = $rootScope.$new();
            element$$1 = $compile(angular.element($div))($scope);
        });
        return element$$1;
    };
    return TestBed;
}());
/** @internal */
function getTestBed() {
    return _testBed = _testBed || new TestBed();
}
// if this syntax looks strange to you, check this out:
// https://github.com/Microsoft/TypeScript/wiki/What's-new-in-TypeScript#user-content-non-null-assertion-operator
/** @internal */
var _testBed = null;
/** @internal */
function camelToKebab(str) {
    return str.replace(/([a-z])([A-Z])/g, '$1-$2').toLowerCase();
}

exports.By = By;
exports.ComponentFixture = ComponentFixture;
exports.DynamicTestModuleId = DynamicTestModuleId;
exports.TestBed = TestBed;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angularjs-testbed.umd.js.map
